---
- name: Configure gitlab runner
  hosts: "{{ hosts_var | default('none') }}"
  become: true

  vars:
    user_name: gitlab-runner
    user_home: "/opt/{{ user_name }}"

  tasks:
    - name: Update apt cache (Debian-based)
      ansible.builtin.apt:
        update_cache: true
        cache_valid_time: 3600
      when: ansible_facts["os_family"] == "Debian"

    - name: Download binary
      ansible.builtin.get_url:
        url: https://gitlab-runner-downloads.s3.amazonaws.com/latest/binaries/gitlab-runner-linux-amd64
        dest: /usr/local/bin/gitlab-runner
        owner: root
        group: root
        mode: 0755
        force: true
      notify: "start gitlab-runner"

    - name: Create GitLab runner user
      ansible.builtin.user:
        name: "{{ user_name }}"
        comment: GitLab Runner
        home: "{{ user_home }}"
        shell: /bin/bash
        state: present

    # FIXME: fix idempotency check for molecule test
    - name: Install GitLab runner as a service
      ansible.builtin.command:
        cmd: "gitlab-runner install --user={{ user_name }} --working-directory={{ user_home }}"
        creates: /etc/systemd/system/gitlab-runner.service
      notify: "start gitlab-runner"

    - name: Install docker to use as executor
      ansible.builtin.import_role:
        name: byron_jones067.docker.docker_common

  handlers:
    - name: Start GitLab service
      when: "'molecule-notest' not in ansible_skip_tags"
      ansible.builtin.service:
        name: gitlab-runner
        state: started
        enabled: true
      listen: "start gitlab-runner"
